' Spinneret Simple TCP Object by "Bean" Sept 14, 2011

VAR
  LONG  data[2]

    
OBJ
  ETHERNET      : "Brilldea_W5100_Indirect_Driver_Ver006"
  

PUB Stop
    ETHERNET.StopINDIRECT


PUB Setup(_MAC0, _MAC1, _MAC2, _MAC3, _MAC4, _MAC5, _IP0, _IP1, _IP2, _IP3, _Gateway0, _Gateway1, _Gateway2, _Gateway3)
  ETHERNET.StartINDIRECT(0, 8, 9, 12, 11, 10, 14, 15)
  data[0] := _MAC0 + _MAC1<<8 + _MAC2<<16 + _MAC3<<24
  data[1] := _MAC4 + _MAC5<<8
  ETHERNET.WriteMACaddress(true, @data)
  data[0] := _IP0 + _IP1<<8 + _IP2<<16 + _IP3<<24
  ETHERNET.WriteIPAddress(true, @data)
  data[0] := _Gateway0 + _Gateway1<<8 + _Gateway2<<16 + _Gateway3<<24
  ETHERNET.WriteGatewayAddress(true, @data)
  data[0] := $00FFFFFF ' Default subnet mask = 255.255.255.0
  ETHERNET.WriteSubnetMask(true, @data)


PUB Subnet(_Subnet0, _Subnet1, _Subnet2, _Subnet3)
  data[0] := _Subnet0 + _Subnet1<<8 + _Subnet2<<16 + _Subnet3<<24
  ETHERNET.WriteSubnetMask(true, @data)
  

PUB Listen(_socket, _port)
  data[0] := 0
  ETHERNET.SocketOpen(_socket, ETHERNET#_TCPPROTO, _port, _port, @data)
  ETHERNET.SocketTCPListen(_socket)


PUB ListenWait(_socket, _port)
  Listen(_socket, _port)
  repeat until isConnected(_socket)

  
PUB Connect(_socket, _SPort, _Dport, _destIP0, _destIP1, _destIP2, _destIP3)
  data[0] := _destIP0 + _destIP1<<8 + _destIP2<<16 + _destIP3<<24 
  ETHERNET.SocketOpen(_socket, ETHERNET#_TCPPROTO, _SPort, _Dport, @data)
  waitcnt(cnt + clkfreq) ' MUST delay here
  ETHERNET.SocketTCPConnect(_socket)
  repeat until (isConnected(_socket)) or (Status(_socket) == 0)
  return isConnected(_socket)
    

PUB Status(_socket) | temp
  ETHERNET.readIND(ETHERNET#_S0_SR + _socket<<8, @temp, 1)
  temp &= $FF
  return temp


PUB isConnected(_socket)
    return Status(_socket) == $17


PUB Send(_socket, _dataPtr, _bytes)
  ETHERNET.txTCP(_socket, _dataPtr, _bytes)


PUB SendStr(_socket, _dataPtr) | _bytes
  _bytes := 0
  repeat while byte[_dataPtr+_bytes] <> 0
    _bytes+=1
  ETHERNET.txTCP(_socket, _dataPtr, _bytes)


PUB Recv(_socket, _dataPtr) | _bytes
  _bytes := ETHERNET.rxTCP(_socket, _dataPtr)
  return _bytes    


PUB RecvStr(_socket, _dataPtr) | _bytes
  _bytes := ETHERNET.rxTCP(_socket, _dataPtr)
  if _bytes > 0
    byte[_dataPtr+_bytes] :=0
  return _bytes    


PUB WaitDisconnect(_socket, _seconds) | startCnt
  startCnt := cnt + clkFreq * _seconds
  repeat while (isConnected(_socket)) and ((cnt-startCnt) < clkFreq * _seconds)  


PUB Disconnect(_socket)
  ETHERNET.SocketTCPDisconnect(_socket)
  repeat until Status(_socket) == $00

  
PUB Close(_socket)
  Disconnect(_socket)
  ETHERNET.SocketClose(_socket)